# -*- coding: utf-8 -*-
"""
Random Walk
@author: jbechtloff

magic Command:
     %matplotlib qt
     %matplotlib inline
"""
import numpy as np
from numpy.random import *

import matplotlib.pyplot as plt
plt.close('all')
plt.style.use('seaborn-whitegrid')


n = 1000


# Rauschanteil
w = np.random.randn(n)

t = np.linspace(0,n-1,n)
    
# Random Walk *****************    
d = np.zeros(n)
rw = np.zeros(n)
crw = np.zeros(n)

tau = 10
a1 = np.exp(-1/tau)
a2 = np.sqrt(1-a1**2)
for k in range(1,n):
    rw[k] = rw[k-1] + w[k] / tau
    
    crw[k] = crw[k-1] + d[k-1]
    d[k] = a1*d[k-1] + a2*w[k-1]
    
    
    
    
fig, ax = plt.subplots(2, 1, figsize = [6,6])

k=0
ax[k].plot(t,rw,color='dimgray', label='rw', linewidth=1)
ax[k].set_ylabel('rw')
ax[k].grid()
k +=1
ax[k].plot(t,crw,color='dimgray', label='crw', linewidth=1.5)
ax[k].set_ylabel('cw')
ax[k].set_xlabel('t')
ax[k].grid()

plt.show()

#fig.savefig(fname="z:ex_2.pdf")
